
background {
	color rgb <0, 0, 0>
	}

global_settings {
	assumed_gamma 1.0
	ambient_light color rgb <1,1,1>
	}

//y: -1.5 - 1.5
//x: -2  - 2	
camera {
	location  <0.0, 0.0, -3.0>
  	look_at   <0.0, 0.0, 0.0>
	}

light_source { <0.0, 0.0, -3.0> color <1, 1, 1> }

//make sure that this value is the same as the framerate in the render settings
//it won't break but the timing will be wrong
//you also need to set the number of frames in the render settings to enough to 
//cover the all the events in the "scorefile"
//the example score is 20 secs so 200 frames with 10fps 
#declare FrameRate=10;

#macro knot (Start, End, NumPoints, Color, Where, Shape)
	
	#local StartFrame = floor(Start*FrameRate);
	#local EndFrame = ceil(End*FrameRate);
	
	#switch(frame_number)
	#range(StartFrame, EndFrame)
	
		#local Time = frame_number/FrameRate - Start;
		#local Num = 1;
		#local Pose = Where(Time);
		
		#while(Num<NumPoints)
			
			sphere_sweep {
				cubic_spline, 4,
				Shape(Num-1), 0.05
				Shape(Num), 0.05
				Shape(Num+1), 0.05
				Shape(Num+2), 0.05
				tolerance .0001
				pigment {  color rgbft <1, 0, 1, 0, clock> }
				translate Pose
				}
			
			#local Num = Num + 1;
		
		#end
		
	#end
	
#end

#macro snake (Start, End, NumPoints, Color, Where, Shape)
	
	#local StartFrame = floor(Start*FrameRate);
	#local EndFrame = ceil(End*FrameRate);
	
	#local Seg = spline { 0, 1, End-Start, NumPoints };
	
	#switch(frame_number)
	
		#range(StartFrame, EndFrame)
	
			#local Time = frame_number/FrameRate - Start;
			#local Num = Seg(Time).red;
			#local Pose = Where(Time);
	
			sphere_sweep {
				cubic_spline, 5,
				Shape(Num-0.5), 0.1
				Shape(Num-0.25), 0.1
				Shape(Num), 0.1
				Shape(Num+0.25), 0.1
				Shape(Num+0.5), 0.1
				tolerance .0001
				pigment { color rgbft <0, 1, 0, 0, clock> }
				translate Pose
				}
					
	#end
	
#end

//put the file output by lisp in the same directory as this file.
#include "test.pov"